Anonymous | Login
Project:
RSS
  
News | My View | View Issues | Roadmap | Summary

View Issue DetailsJump to Notes ] Issue History ] Print ]
ID
0036590
TypeCategorySeverityReproducibilityDate SubmittedLast Update
defect[Openbravo ERP] A. Platformmajoralways2017-08-03 13:282017-09-21 16:49
ReporterJONHMView Statuspublic 
Assigned Tomarkmm82 
PrioritynormalResolutionfixedFixed in Version3.0PR17Q4
StatusclosedFix in branchFixed in SCM revision
ProjectionnoneETAnoneTarget Version
OSAnyDatabaseAnyJava version
OS VersionDatabase versionAnt version
Product VersionpiSCM revision 
Review Assigned Toaferraz
Web browser
ModulesCore
Regression level
Regression date
Regression introduced in release
Regression introduced by commit
Triggers an Emergency PackNo
Summary

0036590: Callouts retrieve wrong quantity when Format.xml file is set with too many decimals

DescriptionWhen adding a product line in physical inventory (which is associated with SL_Inventory_Product callout), the quantity obtained from the product is not real, there are too many zeroes added to the real quantity.
It seems to be related to the configuration of the Format.xml file and its 'qtyRelation' and 'qtyEdition' fields when set with 5 decimals
Steps To Reproduce- First of all, replace the Format.xml file by the attached one. Then, recompile the application.

1) Open "Physical Inventory" window and create a new one with default values.
2) Switch to lines tab and create a new one for product 'Vino Blanco 0,75L'.
--> Notice that the stock for that product is 31300 and the quantity retrieved from the callout is 3130000

(The quantity in database for that product is set as 31300.00)
TagsNo tags attached.
Attached Filesxml file icon Format.xml [^] (3,271 bytes) 2017-08-03 13:28
? file icon callout.mp4 [^] (1,375,339 bytes) 2017-08-03 13:28
diff file icon 36590.diff [^] (5,090 bytes) 2017-08-10 12:45 [Show Content]
diff file icon backport-17Q3.diff [^] (2,783 bytes) 2017-08-18 12:55 [Show Content]

- Relationships Relation Graph ] Dependency Graph ]
duplicate of defect 0036345 closedmarkmm82 Wrong quantity in inventory lines if "," is used as decimal separator and "." as grouping separator 
related to defect 0036392 closedcollazoandy4 Avoid casting to Object when adding numeric results from a SimpleCallout 
related to defect 0036302 closedplatform Display logic in fields is not working in callouts using SimpleCallout 
related to design defect 0036067 closedmarkmm82 old callouts should be refactored to implement SimpleCallout 
depends on backport 00366673.0PR17Q3 closedmarkmm82 Callouts retrieve wrong quantity when Format.xml file is set with too many decimals 
depends on backport 00366683.0PR17Q2.3 closedmarkmm82 Callouts retrieve wrong quantity when Format.xml file is set with too many decimals 
depends on backport 00366693.0PR17Q1.4 closedmarkmm82 Callouts retrieve wrong quantity when Format.xml file is set with too many decimals 

-  Notes
(0098453)
inigosanchez (developer)
2017-08-09 14:13

As mentioned in related issue 0036392, it is needed to replace the castings to Object in the mentioned callout by sending the corresponding numeric value when it applies.
(0098475)
aferraz (developer)
2017-08-10 12:45
edited on: 2017-08-11 14:25

Issue is reproducible in 17Q1.1, 17Q2.1 and 17Q3 but not in PI.
Applied attached fix in 17Q1.1 (send quantities as BigDecimal instead of cast quantity String to Object) and it still fails.

(0098542)
inigosanchez (developer)
2017-08-18 12:54

The usage of "EXECUTE" callout command is no longer supported (since the refactor of the SimpleCallouts 3.0PR16Q4) and it is not needed because the display logics are recalculated on the FIC response.

The refactor 0036067 of several SimpleCallouts fixes the problem in 3.0PR17Q4 but it isn't backported to 17Q1.4, 17Q2.2 and 17Q3. The attached diff fixes the problem in 17Q3 and should be reviewed it (backport-17Q3.diff).

As you can see in the diff, other callouts should be reviewed apart of the reported one (Simple callouts with execute command):
-SL_Inventory_Locator
-SL_Inventory_Product <- Reported
-SL_Movement_Product
-SL_InOutLine_Product
(0098548)
hgbot (developer)
2017-08-18 14:54

Repository: erp/devel/pi
Changeset: b29fcb712528e7603e952d036bf826c4031a9a3a
Author: Alvaro Ferraz <alvaro.ferraz <at> openbravo.com>
Date: Fri Aug 18 14:53:29 2017 +0200
URL: http://code.openbravo.com/erp/devel/pi/rev/b29fcb712528e7603e952d036bf826c4031a9a3a [^]

Related to issue 36590: Send quantities as BigDecimal

---
M src/org/openbravo/erpCommon/ad_callouts/SL_InOutLine_Product.java
M src/org/openbravo/erpCommon/ad_callouts/SL_Inventory_Product.java
M src/org/openbravo/erpCommon/ad_callouts/SL_Movement_Product.java
---
(0098549)
aferraz (developer)
2017-08-18 15:03

Reverted 0036067 fix for SL_Inventory_Product.java in PI and issue is still not reproducible.
Applied 0036067 fix for SL_Inventory_Product.java in 17Q3 and issue is still reproducible.
(0098581)
aferraz (developer)
2017-08-22 14:43

Fixed in issue 0036345.
(0099315)
hudsonbot (developer)
2017-09-21 16:49

A changeset related to this issue has been promoted main and to the
Central Repository, after passing a series of tests.

Promotion changeset: https://code.openbravo.com/erp/devel/main/rev/9750b78d3e5c [^]
Maturity status: Test

- Issue History
Date Modified Username Field Change
2017-08-03 13:28 JONHM New Issue
2017-08-03 13:28 JONHM Assigned To => platform
2017-08-03 13:28 JONHM File Added: Format.xml
2017-08-03 13:28 JONHM Modules => Core
2017-08-03 13:28 JONHM Resolution time => 1503525600
2017-08-03 13:28 JONHM Triggers an Emergency Pack => No
2017-08-03 13:28 JONHM File Added: callout.mp4
2017-08-09 14:09 inigosanchez Relationship added related to 0036392
2017-08-09 14:13 inigosanchez Note Added: 0098453
2017-08-09 14:37 inigosanchez Assigned To platform => Triage Finance
2017-08-09 14:57 aferraz Assigned To Triage Finance => AtulOpenbravo
2017-08-09 17:59 AtulOpenbravo Status new => scheduled
2017-08-10 12:45 aferraz Note Added: 0098475
2017-08-10 12:45 aferraz File Added: 36590.diff
2017-08-10 12:46 aferraz Assigned To AtulOpenbravo => platform
2017-08-10 12:47 aferraz Note Edited: 0098475 View Revisions
2017-08-11 14:25 inigosanchez Note Edited: 0098475 View Revisions
2017-08-18 12:54 inigosanchez Note Added: 0098542
2017-08-18 12:55 inigosanchez File Added: backport-17Q3.diff
2017-08-18 12:57 inigosanchez Relationship added related to 0036302
2017-08-18 12:57 inigosanchez Relationship added related to 0036067
2017-08-18 12:58 inigosanchez Assigned To platform => Triage Finance
2017-08-18 12:59 aferraz Assigned To Triage Finance => inigosanchez
2017-08-18 12:59 aferraz Status scheduled => feedback
2017-08-18 13:00 aferraz Status feedback => scheduled
2017-08-18 14:54 hgbot Checkin
2017-08-18 14:54 hgbot Note Added: 0098548
2017-08-18 15:03 aferraz Note Added: 0098549
2017-08-22 14:43 aferraz Review Assigned To => aferraz
2017-08-22 14:43 aferraz Note Added: 0098581
2017-08-22 14:43 aferraz Status scheduled => closed
2017-08-22 14:43 aferraz Resolution open => fixed
2017-08-22 14:43 aferraz Fixed in Version => 3.0PR17Q4
2017-08-22 14:48 aferraz Relationship added duplicate of 0036345
2017-08-23 08:38 caristu Assigned To inigosanchez => Triage Finance
2017-08-23 10:53 aferraz Assigned To Triage Finance => aferraz
2017-08-23 10:53 aferraz Assigned To aferraz => markmm82
2017-09-21 16:49 hudsonbot Checkin
2017-09-21 16:49 hudsonbot Note Added: 0099315


Copyright © 2000 - 2009 MantisBT Group
Powered by Mantis Bugtracker